local addon, shared = ...

local SILENT=		99
local RELEASE=		90
local TESTING=		20
local WDOGYIELD=	15
local FUNCTIONRUN=	10
local STATUSUPDT=	8
local INFORMATION=	5
local DETAIL=		1

---------------------
-- Variables
---------------------

_raidStatus_Main = {}

local RS = _raidStatus_Main

local UIElements = { status = { party = {} }, sizes = {}, config = { abilities = {}, headers = {} } }

local default_settings = {
	mmx = 250, mmy = 300,
	x = 300, y = 300,
	cfgx = 600, cfgy = 600,
	soulwalks = {}, disabled = {},
	debuglevel = SILENT, version = "1.00.0002"
	}

local statusShown = false
local UPDATENEEDED= false

local soulwalkcd

local FOOD		= 1
local STONE		= 2
local VIAL		= 3
local SHOES		= 4
local ARMOR		= 5
local PLANAR	= 6

local ITEM		= 1
local SPELL		= 2

local MAX_FOOD	=7
local MAX_STONE	=20
local MAX_PLANAR=21
local MAX_VIAL	=37
local MAX_SHOES	=38
local MAX_ARMOR	=39

local _curIconStatus = {}

local _buffDtls = {
-- 1
	{ name = "Ember Steak", cat = FOOD, 					id = "I31959B69773917AF,B3F3EA37BBDC9E82,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\meat_20.dds", active=true },
	{ name = "Dwarven Goulash", cat = FOOD, 				id = "I40314581DB079239,C7B0D9D087069253,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\bowl_of_vegetable_stew.dds", active=true },	
	{ name = "Snapper Jerky", cat = FOOD,					id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\texture\\global\\placeholder_icon.dds", active=true },
	{ name = "Eel Fillet", cat = FOOD,						id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\texture\\global\\placeholder_icon.dds", active=true },
	{ name = "Pome Ambrosia", cat = FOOD,					id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\texture\\global\\placeholder_icon.dds", active=true },

	{ name = "Grilled Steak", cat = FOOD,					id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\food6.dds", active=true },
	{ name = "Jellied Ray", cat = FOOD,						id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\food_18.dds", active=true },
	{ name = "Kelari Spicy Pome", cat = FOOD,				id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\texture\\global\\placeholder_icon.dds", active=true },
	{ name = "Steamed Octopus", cat = FOOD,					id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\meat_17a.dds", active=true },
	{ name = "Shimmersand Gumbo", cat = FOOD,				id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\texture\\global\\placeholder_icon.dds", active=true },

	{ name = "Bacon Rolls", cat = FOOD,						id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\texture\\global\\placeholder_icon.dds", active=true },
	{ name = "Stir Fry", cat = FOOD,						id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\mushroom_a.dds", active=true },
	{ name = "Feast of Aptitude", cat = FOOD, 				id = "I379F77F950B6CE2B,F492E1913A033C25,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\purple_grape.dds", active=true },
	{ name = "Feast of Cooperation", cat = FOOD, 			id = "I3E08CB4B7DC92A6C,4EF5ACD293E6B909,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\food_16.dds", active=true },
	{ name = "Feast of Efficacy", cat = FOOD, 				id = "I05711E6E8F14E021,08506C7295BEDEF7,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\white_grape.dds", active=true },

	{ name = "Farclan Cherry Cake", cat = FOOD, 			id = "I27189C6045B361AA,32AB53EFFE7A416E,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\food_14.dds", active=true },
	{ name = "Kelari Expedition Cherry Cake", cat = FOOD, 	id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\food_14.dds", active=true },
	{ name = "Farclan Chocolate Cake", cat = FOOD, 			id = "I15C541A046F2C8E1,D1BE5BE14FD40EB5,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\food_14a.dds", active=true },
	{ name = "Kelari Expedition Chocolate Cake", cat = FOOD,id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\food_14a.dds", active=true },
-- +19 = 20
	{ name = "Ancient Burning Manastone", cat = STONE,		id = "I76F77140A17CAB4C,F8178CA7822EB198,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\manastone_04.dds", active=true },
	{ name = "Burning Manastone", cat = STONE,				id = "I18315AC1A8FB99E6,D4C324EAC121DDB5,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\manastone_04.dds", active=true },
	{ name = "Ancient Burning Powerstone", cat = STONE,		id = "I4B3B6D62A2371CD7,14AAA9A73F5A2AC9,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\spellstone_04_b.dds", active=true },
	{ name = "Burning Powerstone", cat = STONE,				id = "I79BD18397AF3C969,3C43A37D35321E55,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\spellstone_04_b.dds", active=true },
	{ name = "Ancient Burning Witchstone", cat = STONE,		id = "I532C843CBD033DF2,EAD48E79ABD33E0A,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\texture\\global\\placeholder_icon.dds", active=true },

	{ name = "Burning Witchstone", cat = STONE,				id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\texture\\global\\placeholder_icon.dds", active=true },
	{ name = "Ancient Exquisite Oilstone", cat = STONE,		id = "I0B78B071307D7AF7,053CF0E5CE5FE32C,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\weaponstone_06.dds", active=true },
	{ name = "Exquisite Oilstone", cat = STONE,				id = "I165D9D50534B19B4,F12E517C49EC7856,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\weaponstone_06.dds", active=true },
	{ name = "Ancient Exquisite Whetstone", cat = STONE,	id = "I060113989C963D19,1C4364ACAE024CCB,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\weaponstone_07.dds", active=true },
	{ name = "Exquisite Whetstone", cat = STONE,			id = "I52653315A6280E17,CB5D872D2C915D7C,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\weaponstone_07.dds", active=true },

	{ name = "Ancient Massive Weaponstone", cat = STONE,	id = "I4A0968E7D72592C0,0DA541B0CD125376,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\weaponstone_02_a.dds", active=true },
	{ name = "Massive Weaponstone", cat = STONE,			id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\weaponstone_02_a.dds", active=true },
-- +12 = 32
	{ name = "Baneful Blade", cat = STONE,					id = "A0000000000000000", type = SPELL, lcl = false, icon = "Data/\\UI\\item_icons\\weaponstone_03.dds", active=true },
	{ name = "Barbed Blade", cat = STONE,					id = "A0000000000000000", type = SPELL, lcl = false, icon = "Data/\\UI\\texture\\global\\placeholder_icon.dds", active=true },
	{ name = "Flaring Glyph", cat = STONE,					id = "A0000000000000000", type = SPELL, lcl = false, icon = "Data/\\UI\\item_icons\\spellstone_04_a.dds", active=true },
	{ name = "Icy Glyph", cat = STONE,						id = "A0000000000000000", type = SPELL, lcl = false, icon = "Data/\\UI\\item_icons\\manastone_03_cc.dds", active=true },
	{ name = "Keen Edge", cat = STONE,						id = "A778CD0619B21DD87", type = SPELL, lcl = false, icon = "Data/\\UI\\item_icons\\weaponstone_06.dds", active=true },

	{ name = "Lightning Glyph", cat = STONE,				id = "A0000000000000000", type = SPELL, lcl = false, icon = "Data/\\UI\\item_icons\\enchanting_material_26c.dds", active=true },
	{ name = "Razor Edge", cat = STONE,						id = "A7D7D6E5E89235542", type = SPELL, lcl = false, icon = "Data/\\UI\\item_icons\\weaponstone_04.dds", active=true },
	{ name = "Shielding Glyph", cat = STONE,				id = "A0000000000000000", type = SPELL, lcl = false, icon = "Data/\\UI\\texture\\global\\placeholder_icon.dds", active=true },
	{ name = "Shimmering Glyph", cat = STONE,				id = "A0000000000000000", type = SPELL, lcl = false, icon = "Data/\\UI\\texture\\global\\placeholder_icon.dds", active=true },
	{ name = "Storm Glyph", cat = STONE,					id = "A43070E3DC752DF5C", type = SPELL, lcl = false, icon = "Data/\\UI\\item_icons\\ench_material_15_b.dds", active=true },

	{ name = "Thunder Glyph", cat = STONE,					id = "A0000000000000000", type = SPELL, lcl = false, icon = "Data/\\UI\\texture\\global\\placeholder_icon.dds", active=true },
	{ name = "Vampiric Essence", cat = STONE,				id = "A1160463397A685FC", type = SPELL, lcl = false, icon = "Data/\\UI\\item_icons\\jagged_sourcestone_c.dds", active=true },
	{ name = "Wind Glyph", cat = STONE,						id = "A0000000000000000", type = SPELL, lcl = false, icon = "Data/\\UI\\item_icons\\enchanting_material_11a.dds", active=true },
-- +13 = 45
	{ name = "Planar Protection", cat = PLANAR,				id = "A1295A711A040FDC9", type = SPELL, lcl = false, icon = "Data/\\UI\\ability_icons\\resolve1.dds", active=true },
-- +1 = 46
	{ name = "Vial of Air Resistance", cat = VIAL,			id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\texture\\global\\placeholder_icon.dds", active=true },
	{ name = "Vial of Death Resistance", cat = VIAL,		id = "I59C251A0733E55AF,12706F228D4D4F49,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\heroic_potion_spherical_3.dds", active=true },
	{ name = "Vial of Earth Resistance", cat = VIAL,		id = "I59C251A3A999D609,BA96876DC78F06F0,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\heroic_potion_spherical_2.dds", active=true },
	{ name = "Vial of Fire Resistance", cat = VIAL,			id = "I59C251A57C1DB72E,F31ACA2C75B718A4,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\heroic_potion_spherical_1.dds", active=true },
	{ name = "Vial of Life Resistance", cat = VIAL,			id = "I59C251A159C94474,D5D68B37AB4FD10D,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\heroic_potion_spherical_5.dds", active=true },

	{ name = "Vial of Water Resistance", cat = VIAL,		id = "I59C251A471F12DE9,CC98DE8252EBCE1A,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\heroic_potion_spherical_6.dds", active=true },
	{ name = "Ancient Heroic Brightsurge Vial", cat = VIAL,	id = "I33BD0BAF7081322A,2945D9A7391100BB,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\heroic_potion_spherical_3.dds", active=true },
	{ name = "Heroic Brightsurge Vial", cat = VIAL,			id = "I59C251AE7705F88F,00B04555C48B95B4,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\heroic_potion_spherical_3.dds", active=true },
	{ name = "Mighty Brightsurge Vial", cat = VIAL,			id = "I59C251AF915739D7,F5CE6C0054B1A8F2,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\legendary_potion_spherical_3.dds", active=true },
	{ name = "Ancient Heroic Enduring Vial", cat = VIAL,	id = "I4F44866E6F3DF87F,0B96260CFBF336AE,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\heroic_potion_spherical_5.dds", active=true },

	{ name = "Heroic Enduring Vial", cat = VIAL,			id = "I59C251B27EB31A28,F08FD03D78915A91,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\heroic_potion_spherical_5.dds", active=true },
	{ name = "Mighty Enduring Vial", cat = VIAL,			id = "I59C251B36E6639D7,E5ADF6E808B76DCF,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\legendary_potion_spherical_5.dds", active=true },
	{ name = "Ancient Heroic Fortified Vial", cat = VIAL,	id = "I54694354ABB36CBF,E5FEE11033AAC007,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\heroic_potion_spherical_4.dds", active=true },
	{ name = "Heroic Fortified Vial", cat = VIAL,			id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\heroic_potion_spherical_4.dds", active=true },
	{ name = "Mighty Fortified Vial", cat = VIAL,			id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\legendary_potion_spherical_4.dds", active=true },

	{ name = "Ancient Heroic Powersurge Vial", cat = VIAL,	id = "I030100ADAC40C9EC,0DAE3C95435BB5E4,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\heroic_potion_spherical_1.dds", active=true },
	{ name = "Heroic Powersurge Vial", cat = VIAL,			id = "I59C251B07675D9D0,10E96A92216CC8A9,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\heroic_potion_spherical_1.dds", active=true },
	{ name = "Mighty Powersurge Vial", cat = VIAL,			id = "I59C251B1A5EBCA41,F5FBFC89611CC6ED,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\legendary_potion_spherical_1.dds", active=true },	
-- +18 = 64
	{ name = "Performance Insoles", cat = SHOES,			id = "I5DA91D2D7A632180,4751A6A0E3AE8F7C,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\insoles_04_a.dds", active=true },
	{ name = "Cushioned Insoles", cat = SHOES,				id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\insoles_03.dds", active=true },
-- +2 = 66
	{ name = "Ancient Thick Armor Plating", cat = ARMOR,	id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\armor_plating_04.dds", active=true },
	{ name = "Thick Armor Plating", cat = ARMOR,			id = "I479FD8FD2BA7E3D7,F4C9F6EC7CD1B020,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\armor_plating_04.dds", active=true },
	{ name = "Heavy Armor Plating", cat = ARMOR,			id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\armor_plating_03.dds", active=true },
	{ name = "Medium Armor Plating", cat = ARMOR,			id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\armor_plating_02.dds", active=true },
	{ name = "Thin Armor Plating", cat = ARMOR,				id = "I0000000000000000,0000000000000000,,,,,,", type = ITEM, lcl = false, icon = "Data/\\UI\\item_icons\\armor_plating_01.dds", active=true },
-- +5 = 71	
}

RS._buffDtls = _buffDtls

local _revDtls = {}

RS.rvD = _revDtls

local lastupdate = 0

local _CLASSES = { "warrior", "rogue", "mage", "cleric" }

RS._itemSearch = {
	itemsneeded = false,
	numitemneeded = 0,
	lastsearch = 0,
	firstrun = true,
}

local _itmDtl
local _status
	
local function MergeTable(o,n)
	for k,v in pairs(n) do
		if type(v) == "table" then
			if o[k] == nil then
				o[k] = {}			
			end
	 	 	if type(o[k]) == 'table' then
	 			MergeTable(o[k], n[k])
	 	 	end
		else
			if o[k] == nil then
				o[k] = v
			end
		end
	end
end

local debuglevel = default_settings.debuglevel
local _debugmessages = {}
debuglevel = WDOGYIELD
local function Debug(s,l)
	if (l or INFORMATION) >= debuglevel then
		print(s)
	end
	table.insert(_debugmessages, { tx = os.date("%Y%m%d-%H:%M:%S"), lvl = l, msg = s })
end

local _watchdogyield = {}
local yieldcnt = 0
local function WATCHDOGWAIT(x)
	local rmx = Inspect.System.Watchdog()
	while rmx < 0.03 do
		yieldcnt = yieldcnt+1
		Debug("#"..yieldcnt..":rmx: "..rmx.." ["..x.."]",WDOGYIELD)
		_watchdogyield[yieldcnt] = { tx = os.date("%Y%m%d-%H:%M:%S"), m = x, tr = rmx }
		coroutine.yield()
		rmx = Inspect.System.Watchdog()
	end
end

function RS.FillBar(x,d,b)
	local bw = UIElements.sizes.fr_w
	local s = d.name
	if d.afk == true then s = s .. "[AFK]" end
	if d.pvp == true then s = s .. "[PVP]" end

	UIElements.status.party[x].name:SetText(s)
	
	if d.availability == "full" then
		local v = d.vitality
		UIElements.status.party[x].name:SetFontColor(1,1,1,1)
		UIElements.status.party[x].reptxt:SetText(string.format("[%d%%]", v))
		
		UIElements.status.party[x].reptxt:SetFontColor(1-(v/100),(v/100),0)
		UIElements.status.party[x].charge:SetText(string.format("%d/%d", d.planar, d.planarMax))

		if d.calling == "cleric" or d.calling == "mage" then
			UIElements.status.party[x].power:SetWidth(bw*(d.mana/d.manaMax))
		else
			UIElements.status.party[x].power:SetWidth(0)
		end
	
	else
		UIElements.status.party[x].name:SetFontColor(0.5,0.5,0.5,1)
		UIElements.status.party[x].reptxt:SetText("")
		UIElements.status.party[x].power:SetWidth(0)
		UIElements.status.party[x].charge:SetText("")
	end

	local sw = RaidStatus_Settings.soulwalks[d.name]
	if sw ~= nil then
		local tx = sw - os.time()
		if tx > 0 then
			UIElements.status.party[x].soulwalk:SetVisible(true)
			if tx > 60 then
				UIElements.status.party[x].soultxt:SetText(string.format("%dm", math.floor(tx/60)))
			else
				UIElements.status.party[x].soultxt:SetText(string.format("%ds", tx))
			end
		else
			RaidStatus_Settings.soulwalks[d.name] = nil
			UIElements.status.party[x].soulwalk:SetVisible(false)
		end
	else
		UIElements.status.party[x].soulwalk:SetVisible(false)
	end
	
	local actBuff = { [FOOD] = "", [STONE] = "", [VIAL] = "", [SHOES] = "", [ARMOR] ="", [PLANAR] = "" }

	for k,v in pairs(b) do
		if _revDtls[v.name] ~= nil then
			local ix = _revDtls[v.name]
			if _buffDtls[ix].lcl == false or _buffDtls[ix].active == true then
				if v.icon ~= nil then
					if v.icon ~= _buffDtls[ix].icon then
						_buffDtls[ix].icon = v.icon
						UIElements.config.abilities[ix].icon:SetTexture("Rift", v.icon)
						RaidStatus_ItemDetails.icn[v.name] = v.icon
					end
				end
				actBuff[_buffDtls[ix].cat] = _buffDtls[ix].icon
			end
		end
	end
	
	for k,v in pairs(actBuff) do
		if v ~= "" then
			UIElements.status.party[x].buffs[k]:SetTexture("Rift", v)
			UIElements.status.party[x].buffs[k]:SetVisible(true)
		else
			UIElements.status.party[x].buffs[k]:SetVisible(false)
		end
	end
	
	UIElements.status.party[x].frame:SetVisible(true)
end

function RS.BuildBuffLookup()
	_revDtls = {}
	for k,v in pairs(_buffDtls) do
		_revDtls[v.name] = k
		if v.lcl == false then
			if _curIconStatus[v.id] ~= "ERROR" then
				UIElements.config.abilities[k].status:SetTexture(addon.identifier, "textures/error.png")
				_curIconStatus[v.id] = "ERROR"
			end
		else
			if v.active == true then
				if _curIconStatus[v.id] ~= "ACCEPT" then
					UIElements.config.abilities[k].status:SetTexture(addon.identifier, "textures/accept.png")
					_curIconStatus[v.id] = "ACCEPT"
				end
			else
				if _curIconStatus[v.id] ~= "CANCEL" then
					UIElements.config.abilities[k].status:SetTexture(addon.identifier, "textures/cancel.png")
					_curIconStatus[v.id] = "CANCEL"
				end
			end
		end
	end
end

function RS.CreateUI()

	WATCHDOGWAIT("CreateUI:1")

	UIElements.context = UI.CreateContext(addon.identifier)
	
	UIElements.minimap = UI.CreateFrame("Texture", "RS.UIElements.minimap", UIElements.context)
	UIElements.minimap:SetHeight(36)
	UIElements.minimap:SetWidth(36)
	UIElements.minimap:SetTexture(addon.identifier, "textures/mm_button.png")
	UIElements.minimap:SetPoint("TOPLEFT", UIParent, "TOPLEFT", RaidStatus_Settings.mmx, RaidStatus_Settings.mmy)

	function UIElements.minimap.Event:LeftDown()
		self.MouseDown = true
		local mouseData = Inspect.Mouse()
		self.sx = mouseData.x - UIElements.minimap:GetLeft()
		self.sy = mouseData.y - UIElements.minimap:GetTop()
	end
	
	function UIElements.minimap.Event:MouseMove()
		if self.MouseDown then
			local nx, ny
			local mouseData = Inspect.Mouse()
			nx = mouseData.x - self.sx
			ny = mouseData.y - self.sy
			UIElements.minimap:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx,ny)
		end
	end
	
	function UIElements.minimap.Event:LeftUp()
		if self.MouseDown then
			self.MouseDown = false
		end
		RaidStatus_Settings.mmx = UIElements.minimap:GetLeft()
		RaidStatus_Settings.mmy = UIElements.minimap:GetTop()
	end	
	
	function UIElements.minimap.Event:RightDown()
		self.downtime = Inspect.Time.Real()
	end

	function UIElements.minimap.Event:RightUp()
		if Inspect.Time.Real() - self.downtime > 2 then
			UIElements.config.header:SetVisible(true)
		end
	end
	
	function UIElements.minimap.Event:RightClick()
		if Inspect.Time.Real() - self.downtime < 2 then
			statusShown = not statusShown
			if statusShown then
				UIElements.status.header:SetBackgroundColor(0.5,0,0)
			else
				UIElements.status.header:SetBackgroundColor(0,0,0.5)
			end
			UIElements.status.frame:SetVisible(statusShown)
			UPDATENEEDED = statusShown
		end
	end
	
	function UIElements.minimap.Event:MouseIn()
		UIElements.status.frame:SetVisible(true)
		UPDATENEEDED = true
	end

	function UIElements.minimap.Event:MouseOut()
		if statusShown == false then
			UIElements.status.frame:SetVisible(false)
			UPDATENEEDED = false
		end
	end

	WATCHDOGWAIT("CreateUI:2")
	
	UIElements.status.frame = UI.CreateFrame("Frame", "UIElements.status.frame", UIElements.context)
	UIElements.status.frame:SetVisible(false)
	UIElements.status.frame:SetLayer(1)
	UIElements.status.frame:SetBackgroundColor(0.15, 0.15, 0.15, 0.85)
	UIElements.status.frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", RaidStatus_Settings.x, RaidStatus_Settings.y)
	--UIElements.status.frame:SetBackgroundColor(0,0,0,1)

	function UIElements.status.frame.Event:LeftDown()
		self.MouseDown = true
		local mouseData = Inspect.Mouse()
		self.sx = mouseData.x - UIElements.status.frame:GetLeft()
		self.sy = mouseData.y - UIElements.status.frame:GetTop()
	end
	
	function UIElements.status.frame.Event:MouseMove()
		if self.MouseDown then
			local nx, ny
			local mouseData = Inspect.Mouse()
			nx = mouseData.x - self.sx
			ny = mouseData.y - self.sy
			UIElements.status.frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx,ny)
		end
	end
	
	function UIElements.status.frame.Event:LeftUp()
		if self.MouseDown then
			self.MouseDown = false
		end
		RaidStatus_Settings.x = UIElements.status.frame:GetLeft()
		RaidStatus_Settings.y = UIElements.status.frame:GetTop()
	end
	
	WATCHDOGWAIT("CreateUI:3")
	
	UIElements.status.title = UI.CreateFrame("Text", "UIElements.status.title", UIElements.status.frame)
	UIElements.status.title:SetText("Raid Status Monitor")
	UIElements.status.title:SetLayer(3)

	UIElements.status.title:SetFontSize(12)
	UIElements.sizes.h12 = UIElements.status.title:GetHeight()
	UIElements.status.title:SetFontSize(14)
	UIElements.sizes.h14 = UIElements.status.title:GetHeight()
	UIElements.status.title:SetFontSize(16)
	UIElements.sizes.h16 = UIElements.status.title:GetHeight()
	UIElements.status.title:SetFontSize(18)
	UIElements.sizes.h18 = UIElements.status.title:GetHeight()
	
	UIElements.sizes.tit_w = UIElements.status.title:GetWidth()
	
	UIElements.status.header = UI.CreateFrame("Frame", "UIElements.status.header", UIElements.status.frame)
	UIElements.status.header:SetHeight(UIElements.sizes.h18)
	UIElements.status.header:SetLayer(2)
	
	UIElements.status.header:SetBackgroundColor(0,0,0.5)
	UIElements.status.header:SetPoint("TOPLEFT", UIElements.status.frame, "TOPLEFT", 0,0)
	UIElements.status.title:SetPoint("CENTER", UIElements.status.header, "CENTER", 0,0)
	UIElements.status.frame:SetHeight(UIElements.sizes.h18 * 5)
	
	for x = 1, 20 do
		WATCHDOGWAIT("CreateUI:4:"..x)
		local f = {}
		f.frame = UI.CreateFrame("Frame", "f.frame", UIElements.status.frame)
		f.frame:SetLayer(2)
		
		f.power = UI.CreateFrame("Frame", "f.power", f.frame)
		f.power:SetPoint("BOTTOMLEFT", f.frame, "BOTTOMLEFT", 0,0)
		f.power:SetHeight(4)
		f.power:SetLayer(4)
		f.power:SetBackgroundColor(0,0,1,1)
		
		f.name = UI.CreateFrame("Text", "f.name", f.frame)
		f.name:SetFontSize(12)
		f.name:SetPoint("CENTERLEFT", f.frame, "CENTERLEFT", 2,0)
		f.name:SetLayer(3)
		f.name:SetText(string.format("GROUPMEMBER #%02d", x))

		f.charge = UI.CreateFrame("Text", "f.charge", f.frame)
		f.charge:SetFontSize(12)
		f.charge:SetPoint("CENTERRIGHT", f.frame, "CENTERRIGHT", -2,0)
		f.charge:SetLayer(5)
		f.charge:SetText("9/9")
		
		f.reptxt = UI.CreateFrame("Text", "f.reptxt", f.frame)
		f.reptxt:SetFontSize(12)
		f.reptxt:SetPoint("CENTERRIGHT", f.charge, "CENTERLEFT", -2,0)
		f.reptxt:SetLayer(5)
		f.reptxt:SetText("[100%]")
		WATCHDOGWAIT("CreateUI:4a:"..x)
				
		f.soulwalk = UI.CreateFrame("Texture", "f.soulwalk", f.frame)
		f.soulwalk:SetHeight(UIElements.sizes.h12)
		f.soulwalk:SetWidth(UIElements.sizes.h12)
		f.soulwalk:SetLayer(6)
		f.soulwalk:SetTexture("Rift", "Data/\\UI\\item_icons\\offhand_skull_007a.dds")
		f.soulwalk:SetPoint("TOPRIGHT", f.reptxt, "TOPLEFT", 0,0)
		
		f.soultxt = UI.CreateFrame("Text", "f.soultxt", f.soulwalk)
		f.soultxt:SetFontSize(12)
		f.soultxt:SetPoint("CENTER", f.soulwalk, "CENTER", 2,0)
		f.soultxt:SetLayer(8)
		f.soultxt:SetText("55m")
		
		f.buffs = {}
		
		f.buffs[FOOD] = UI.CreateFrame("Texture", "f.buffs[FOOD]", f.frame)
		f.buffs[FOOD]:SetHeight(UIElements.sizes.h12)
		f.buffs[FOOD]:SetWidth(UIElements.sizes.h12)
		f.buffs[FOOD]:SetLayer(6)
		f.buffs[FOOD]:SetPoint("TOPRIGHT", f.soulwalk, "TOPLEFT",0,0)

		f.buffs[STONE] = UI.CreateFrame("Texture", "f.buffs[STONE]", f.frame)
		f.buffs[STONE]:SetHeight(UIElements.sizes.h12)
		f.buffs[STONE]:SetWidth(UIElements.sizes.h12)
		f.buffs[STONE]:SetLayer(6)
		f.buffs[STONE]:SetPoint("TOPRIGHT", f.buffs[FOOD], "TOPLEFT", 0,0)
		
		f.buffs[VIAL] = UI.CreateFrame("Texture", "f.buffs[VIAL]", f.frame)
		f.buffs[VIAL]:SetHeight(UIElements.sizes.h12)
		f.buffs[VIAL]:SetWidth(UIElements.sizes.h12)
		f.buffs[VIAL]:SetLayer(6)
		f.buffs[VIAL]:SetPoint("TOPRIGHT", f.buffs[STONE], "TOPLEFT", 0,0)
		WATCHDOGWAIT("CreateUI:4b:"..x)

		f.buffs[PLANAR] = UI.CreateFrame("Texture", "f.buffs[PLANAR]", f.frame)
		f.buffs[PLANAR]:SetHeight(UIElements.sizes.h12)
		f.buffs[PLANAR]:SetWidth(UIElements.sizes.h12)
		f.buffs[PLANAR]:SetLayer(6)
		f.buffs[PLANAR]:SetPoint("TOPRIGHT", f.buffs[VIAL], "TOPLEFT", 0,0)

		f.buffs[SHOES] = UI.CreateFrame("Texture", "f.buffs[SHOES]", f.frame)
		f.buffs[SHOES]:SetHeight(UIElements.sizes.h12)
		f.buffs[SHOES]:SetWidth(UIElements.sizes.h12)
		f.buffs[SHOES]:SetLayer(6)
		f.buffs[SHOES]:SetPoint("TOPRIGHT", f.buffs[PLANAR], "TOPLEFT", 0,0)

		f.buffs[ARMOR] = UI.CreateFrame("Texture", "f.buffs[ARMOR]", f.frame)
		f.buffs[ARMOR]:SetHeight(UIElements.sizes.h12)
		f.buffs[ARMOR]:SetWidth(UIElements.sizes.h12)
		f.buffs[ARMOR]:SetLayer(6)
		f.buffs[ARMOR]:SetPoint("TOPRIGHT", f.buffs[SHOES], "TOPLEFT", 0,0)

		
		UIElements.sizes.chg_w = f.charge:GetWidth()
		UIElements.sizes.pct_w = f.reptxt:GetWidth()
		
		UIElements.sizes.fr_w = UIElements.sizes.tit_w+UIElements.sizes.pct_w+(2*UIElements.sizes.chg_w)+2
		
		f.charge:SetWidth(UIElements.sizes.chg_w)
		f.reptxt:SetWidth(UIElements.sizes.pct_w)
		
		f.frame:SetWidth(UIElements.sizes.fr_w)
		f.frame:SetHeight(UIElements.sizes.h12+4)
		
		UIElements.status.party[x] = f
	end
	
	WATCHDOGWAIT("CreateUI:5")
	
	UIElements.status.header:SetWidth(UIElements.sizes.tit_w+UIElements.sizes.pct_w+(2*UIElements.sizes.chg_w)+4)
	UIElements.status.frame:SetWidth(UIElements.sizes.tit_w+UIElements.sizes.pct_w+(2*UIElements.sizes.chg_w)+4)
	UIElements.status.frame:SetHeight(UIElements.sizes.h18 + 20*(UIElements.sizes.h12+6) + 1)
	
	UIElements.config.header = UI.CreateFrame("Frame", "UIElements.config.header", UIElements.context)
	UIElements.config.header:SetVisible(false)
	UIElements.config.header:SetLayer(1)
	UIElements.config.header:SetBackgroundColor(0,0,0.75)
	UIElements.config.header:SetHeight(UIElements.sizes.h18)
	UIElements.config.header:SetPoint("TOPLEFT", UIParent, "TOPLEFT", RaidStatus_Settings.cfgx, RaidStatus_Settings.cfgy)

	function UIElements.config.header.Event:LeftDown()
		self.MouseDown = true
		local mouseData = Inspect.Mouse()
		self.sx = mouseData.x - UIElements.config.header:GetLeft()
		self.sy = mouseData.y - UIElements.config.header:GetTop()
	end
	
	function UIElements.config.header.Event:MouseMove()
		if self.MouseDown then
			local nx, ny
			local mouseData = Inspect.Mouse()
			nx = mouseData.x - self.sx
			ny = mouseData.y - self.sy
			UIElements.config.header:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx,ny)
		end
	end
	
	function UIElements.config.header.Event:LeftUp()
		if self.MouseDown then
			self.MouseDown = false
		end
		RaidStatus_Settings.cfgx = UIElements.config.header:GetLeft()
		RaidStatus_Settings.cfgy = UIElements.config.header:GetTop()
	end
		
	UIElements.config.title = UI.CreateFrame("Text", "UIElements.config.title", UIElements.config.header)
	UIElements.config.title:SetPoint("CENTER", UIElements.config.header, "CENTER", 0,0)
	UIElements.config.title:SetFontSize(18)
	UIElements.config.title:SetLayer(2)
	UIElements.config.title:SetText("RAID STATUS Configuration")
	
	UIElements.config.close = UI.CreateFrame("Texture", "UIElements.config.close", UIElements.config.header)
	UIElements.config.close:SetHeight(UIElements.sizes.h18)
	UIElements.config.close:SetWidth(UIElements.sizes.h18)
	UIElements.config.close:SetLayer(3)
	UIElements.config.close:SetPoint("TOPRIGHT", UIElements.config.header, "TOPRIGHT", 0,0)
	UIElements.config.close:SetTexture(addon.identifier, "textures/cancel.png")
	
	function UIElements.config.close.Event:LeftClick()
		UIElements.config.header:SetVisible(false)
	end
	
	UIElements.config.container = UI.CreateFrame("Frame", "UIElements.config.container", UIElements.config.header)
	UIElements.config.container:SetPoint("TOPLEFT", UIElements.config.header, "BOTTOMLEFT", 0,0)
	UIElements.config.container:SetHeight( (UIElements.sizes.h14*2)+(UIElements.sizes.h12*37)+ 4)
	UIElements.config.container:SetLayer(1)
	UIElements.config.container:SetBackgroundColor(0,0,0,0.5)
	
	local _headers = { "FOOD", "STONES", "GLYPHS", "PLANAR PROTECTION", "VIALS", "SHOES", "ARMOR" }
	
	local colwidth = 0
	
	for x = 1,7 do
		WATCHDOGWAIT("CreateUI:6:"..x)
		local f = {}
		f.title = UI.CreateFrame("Text", "f.title", UIElements.config.header)
		f.title:SetFontSize(14)
		f.title:SetLayer(2)
--		f.title:SetWidth(197)
		f.title:SetText(_headers[x])
		colwidth = math.max(colwidth, f.title:GetWidth())
		f.title:SetBackgroundColor(0,0,1)
		
		UIElements.config.headers[x] = f
	end
	
	for k,v in ipairs(_buffDtls) do
		WATCHDOGWAIT("CreateUI:7:"..k)
		local f = {}
		
		f.frame = UI.CreateFrame("Frame", "f.frame", UIElements.config.header)
--		f.frame:SetWidth(197)
		f.frame:SetLayer(2)
		f.frame:SetHeight(UIElements.sizes.h12)
		
		f.icon = UI.CreateFrame("Texture", "f.icon"..k, UIElements.config.header)
		f.icon:SetHeight(UIElements.sizes.h12)
		f.icon:SetWidth(UIElements.sizes.h12)
		f.icon:SetLayer(4)
		f.icon:SetPoint("TOPLEFT", f.frame, "TOPLEFT", 0,0)
		f.icon:SetTexture('Rift', v.icon)
		
		f.name = UI.CreateFrame("Text", "f.name", UIElements.config.header)
		f.name:SetFontSize(12)
		f.name:SetLayer(3)
		f.name:SetText(v.name)
		colwidth = math.max(colwidth, f.name:GetWidth())
		f.name:SetPoint("TOPLEFT", f.icon, "TOPRIGHT", 0,0)
		
		f.status = UI.CreateFrame("Texture", "f.status"..k, UIElements.config.header)
		f.status:SetHeight(UIElements.sizes.h12)
		f.status:SetWidth(UIElements.sizes.h12)
		f.status:SetLayer(4)
		f.status:SetPoint("TOPRIGHT", f.frame, "TOPRIGHT", 0,0)

		local id = _buffDtls[k].id
		if _buffDtls[k].lcl == true then
			if RaidStatus_Settings.disabled[id] then
				_curIconStatus[id] = "CANCEL"
				f.status:SetTexture(addon.identifier, "textures/cancel.png")
			else
				_curIconStatus[id] = "ACCEPT"
				f.status:SetTexture(addon.identifier, "textures/accept.png")
			end
		else
			_curIconStatus[id] = "ERROR"
			f.status:SetTexture(addon.identifier, "textures/error.png")
		end
		
		function f.status.Event:LeftClick()
			if _buffDtls[k].lcl == true then
				local id = _buffDtls[k].id
				if RaidStatus_Settings.disabled[id] then
					RaidStatus_Settings.disabled[id] = nil
					_buffDtls[k].active = true
					f.status:SetTexture(addon.identifier, "textures/accept.png")
				else
					RaidStatus_Settings.disabled[id] = true
					f.status:SetTexture(addon.identifier, "textures/cancel.png")
					_buffDtls[k].active = false
				end
			end
		end
		
		UIElements.config.abilities[k] = f
		local _hdr = 0
		
		if k == 1 then
			_hdr = 1
			UIElements.config.headers[_hdr].title:SetPoint("TOPLEFT", UIElements.config.header, "BOTTOMLEFT", 2,2)
			UIElements.config.abilities[1].frame:SetPoint("TOPLEFT", UIElements.config.headers[_hdr].title, "BOTTOMLEFT", 0,0)
		elseif k == 20 then
			_hdr = 2
			UIElements.config.headers[_hdr].title:SetPoint("TOPLEFT", UIElements.config.headers[1].title, "TOPRIGHT", 2,0)
			UIElements.config.abilities[k].frame:SetPoint("TOPLEFT", UIElements.config.headers[_hdr].title, "BOTTOMLEFT", 0,0)		
		elseif k == 32 then
			_hdr = 3
			UIElements.config.headers[_hdr].title:SetPoint("TOPLEFT", UIElements.config.abilities[k-1].frame, "BOTTOMLEFT", 0,0)
			UIElements.config.abilities[k].frame:SetPoint("TOPLEFT", UIElements.config.headers[_hdr].title, "BOTTOMLEFT", 0,0)			
		elseif k == 45 then
			_hdr = 4
			UIElements.config.headers[_hdr].title:SetPoint("TOPLEFT", UIElements.config.abilities[k-1].frame, "BOTTOMLEFT", 0,0)
			UIElements.config.abilities[k].frame:SetPoint("TOPLEFT", UIElements.config.headers[_hdr].title, "BOTTOMLEFT", 0,0)
		elseif k == 46 then
			_hdr = 5
			UIElements.config.headers[_hdr].title:SetPoint("TOPLEFT", UIElements.config.abilities[19].frame, "BOTTOMLEFT", 0,0)
			UIElements.config.abilities[k].frame:SetPoint("TOPLEFT", UIElements.config.headers[_hdr].title, "BOTTOMLEFT", 0,0)
		elseif k == 64 then
			_hdr = 6
			UIElements.config.headers[_hdr].title:SetPoint("TOPLEFT", UIElements.config.abilities[45].frame, "BOTTOMLEFT", 0,0)
			UIElements.config.abilities[k].frame:SetPoint("TOPLEFT", UIElements.config.headers[_hdr].title, "BOTTOMLEFT", 0,0)
		elseif k == 66 then
			_hdr = 7
			UIElements.config.headers[_hdr].title:SetPoint("TOPLEFT", UIElements.config.abilities[k-1].frame, "BOTTOMLEFT", 0,0)
			UIElements.config.abilities[k].frame:SetPoint("TOPLEFT", UIElements.config.headers[_hdr].title, "BOTTOMLEFT", 0,0)
		else
			UIElements.config.abilities[k].frame:SetPoint("TOPLEFT", UIElements.config.abilities[k-1].frame, "BOTTOMLEFT", 0,0)
		end
	end
	
	colwidth = colwidth + (2*UIElements.sizes.h12) + 2
	
	for k,v in pairs(UIElements.config.headers) do
		v.title:SetWidth(colwidth)
	end
	
	for k,v in pairs(UIElements.config.abilities) do
		v.frame:SetWidth(colwidth)
	end
	
	UIElements.config.container:SetWidth((colwidth*2)+6)
	UIElements.config.header:SetWidth((colwidth*2)+6)
end

function RS.ConvertSettings(v)
	if v < "1.00.0001" then
		RaidStatus_ItemDetails = {}
		RaidStatus_Settings.savedDtls = nil
	end
	if v < "1.00.0002" then
		local tmp = {}
		MergeTable(tmp, RaidStatus_ItemDetails)
		RaidStatus_ItemDetails = { ids = {}, icn = {} }
		MergeTable(RaidStatus_ItemDetails.ids, tmp)
	end
	RaidStatus_Settings.version = default_settings.version
end

function RS.SVLoaded()
	if RaidStatus_Settings == nil then RaidStatus_Settings = {} end
	if RaidStatus_ItemDetails == nil then RaidStatus_ItemDetails = { ids = {}, icn = {} } end
	
	local sv_ver = RaidStatus_Settings.version or "0.00.0000"
	if sv_ver < default_settings.version then
		RS.ConvertSettings(sv_ver)
	end
	
	MergeTable(RaidStatus_Settings, default_settings)
	
	for k,v in pairs(RaidStatus_Settings.soulwalks) do
		if v < os.time() then
			RaidStatus_Settings.soulwalks[k] = nil
		end
	end
	
	local c1 = 0
	local c2 = 0
	
	if Inspect.System.Language() == "English" then
		for k,v in pairs(_buffDtls) do
			_buffDtls[k].lcl = true
			if RaidStatus_Settings.disabled[v.id] == true then
				_buffDtls[k].active = false
			end
		end
	else
		for k,v in pairs(_buffDtls) do
			c1 = c1+1
			if RaidStatus_ItemDetails.ids[v.id] ~= nil then
				local locname = RaidStatus_ItemDetails.ids[v.id].name
	--			print(string.format("%s -> %s", _buffDtls[k].name, locname))
				_buffDtls[k].name = locname
				_buffDtls[k].icon = RaidStatus_ItemDetails.ids[v.id].icon
				_buffDtls[k].lcl = true
				c2 = c2+1
			end
			if RaidStatus_Settings.disabled[v.id] == true then
				_buffDtls[k].active = false
			end
		end
		
		if c2 > 0 then
			ItemUpdateNeeded = true
		end
		
		if c2 < c1 then
			print(string.format("Found %d of %d entries in history. Searching for remainder", c2, c1))
			RS._itemSearch.itemsneeded = true
		end
	end

	for k,v in pairs(_buffDtls) do
		if RaidStatus_ItemDetails.icn[v.name] ~= nil then
			if v.icon ~= RaidStatus_ItemDetails.icn[v.name] then
				_buffDtls[k].icon = RaidStatus_ItemDetails.icn[v.name]
			end
		end
	end
	
end

local SVLoaded = false
local UINeeded = false
local ItemUpdateNeeded = false

function RS.UpdateHandler()
	local barsupdate = 0
	local itemupdate = 0
	local thisupdate = 0
	
	while true do
		thisupdate = Inspect.Time.Real()
		if SVLoaded then
			RS.SVLoaded()
			SVLoaded = false
			UINeeded = true
		elseif UINeeded then
			RS.CreateUI()
			UINeeded = false
		elseif (thisupdate - itemupdate > 2) and RS._itemSearch.itemsneeded then
			RS.FindItemUpdates()
			itemupdate = thisupdate
		elseif ItemUpdateNeeded then
			RS.BuildBuffLookup()
			ItemUpdateNeeded = false
		elseif UPDATENEEDED and (thisupdate - barsupdate > 1) then
			barsupdate = thisupdate
			RS.UpdateDisplay()
		end
		coroutine.yield()
	end
end

function RS.FindItemUpdates()
	local itemtypes = {}
	local cnt = 0

	for k,v in pairs(_buffDtls) do
		if v.lcl == false and v.type == ITEM then
			cnt = cnt+1
			itemtypes[v.id] = true
		end
	end
				
	if cnt > 0 then
	
		if RS._itemSearch.firstrun == true then
			print(string.format("NOTICE: Need to find details for %d items.", cnt))
			RS._itemSearch.firstrun = false
			RS._itemSearch.numitemsneeded = cnt
		end

		_status, _itmDtl = pcall(Inspect.Item.Detail, itemtypes)
		local found = 0
		if _status and _itmDtl then
			for k,v in pairs(_itmDtl) do
				found = found+1
				RaidStatus_ItemDetails.ids[k] = { name = v.name, icon = v.icon }
			end
		end
		if found > 0 then
			print(string.format("NOTICE: Found %d of the missing %d item details", found, RS._itemSearch.numitemsneeded))
			RS._itemSearch.numitemsneeded = RS._itemSearch.numitemsneeded - found
			for k,v in pairs(_buffDtls) do
				if v.type == ITEM and v.lcl == false then
					if RaidStatus_ItemDetails.ids[v.id] ~= nil then
						_buffDtls[k].name = RaidStatus_ItemDetails.ids[v.id].name
						_buffDtls[k].icon = RaidStatus_ItemDetails.ids[v.id].icon
						_buffDtls[k].lcl = true
					end
				end
			end
			ItemUpdateNeeded = true
		end
	else
		RS._itemSearch.itemsneeded = false
	end
end			

function RS.UpdateDisplay()
	local cnt_r = 0
	local cnt_f = 0
	local prv = 0
	local cur = 0
	for x = 1, 20 do
		local s = string.format("group%02d", x)
		local d = Inspect.Unit.Detail(s)
		if d ~= nil then
			local b = {}
			if d.availability == "full" then
				b = Inspect.Buff.Detail(s, Inspect.Buff.List(s))
			end
			cnt_r = cnt_r+1
			RS.FillBar(x, d, b)
			cur = x
		else
			if statusShown then
				cnt_f = cnt_f+1
				local d = {
					name = string.format("GROUPMEMBER %02d", x),
					availability = "full", vitality = (x*5),
					planar=(x%10), planarMax=9,
					calling = _CLASSES[(x%4)+1], mana = (x*5), manaMax = 100
					}
				local b = {
					{name = _buffDtls[3].name},
					{name = _buffDtls[24].name},
					{name = _buffDtls[37].name},
				}
				RaidStatus_Settings.soulwalks[d.name] = os.time() + (x*60)
				RS.FillBar(x, d, b)
				cur = x
			else
				UIElements.status.party[x].frame:SetVisible(false)
			end
		end
		
		if cur ~= prv then
			if prv == 0 then
				UIElements.status.party[cur].frame:SetPoint("TOPLEFT", UIElements.status.header, "BOTTOMLEFT", 0,0)
			else
				UIElements.status.party[cur].frame:SetPoint("TOPLEFT", UIElements.status.party[prv].frame, "BOTTOMLEFT", 0,2)
			end
			prv = x
		end
	end
	if cnt_r == 0 then
		cnt_r = 1
		if statusShown then cnt_f = 19 end
		local d = Inspect.Unit.Detail("player")
		local b = Inspect.Buff.Detail("player", Inspect.Buff.List("player"))
		RS.FillBar(1, d, b)
		UIElements.status.party[1].frame:SetPoint("TOPLEFT", UIElements.status.header, "BOTTOMLEFT", 0,0)
	end
	UIElements.status.frame:SetHeight(UIElements.sizes.h18 + (cnt_r+cnt_f)*(UIElements.sizes.h12+6) + 1)
end

RS.coUpdateHandler = coroutine.create(RS.UpdateHandler)

function RS.OnUpdate()
	if coroDead then return end
	local ok, errormsg = coroutine.resume(RS.coUpdateHandler)
	if not ok then
		coroDead = true
		error("Error in coroutine: "..errormsg)
	end
end

function RS.AdEvent(u,t)
	local bd = Inspect.Buff.Detail(u,t)
	for k,v in pairs(bd) do
		if v.abilityNew == "A5EECF6A771DF52E9" then
			local d = Inspect.Unit.Detail(u)
			RaidStatus_Settings.soulwalks[d.name] = os.time() + soulwalkcd
		end
	end
end

local _playerFound = false

function RS.PlayerAvailable(t)
	if _playerFound == false then
		for k,v in pairs(t) do
			if v == "player" then
				_playerFound = true
				local d = Inspect.Ability.New.Detail("A5EECF6A771DF52E9")
				if d ~= nil then
					soulwalkcd = d.cooldown
				end
--[[				
				for k,v in pairs(_buffDtls) do
					if v.type == SPELL and v.lcl == false then
						local d = Inspect.Ability.New.Detail(v.id)
						if d ~= nil then
--							print(string.format("%s -> %s", _buffDtls[k].name, d.name))
							_buffDtls[k].name = d.name
							_buffDtls[k].icon = d.icon
							_buffDtls[k].lcl = true
							
							RaidStatus_ItemDetails[v.id] = { name = d.name, icon = d.icon }
						end
					end
				end
]]				
				ItemUpdateNeeded = true
			end
		end
	end
end

---------------------
-- Register Events
---------------------

table.insert(Event.System.Update.Begin, { RS.OnUpdate, addon.identifier, "Event.System.Update.Begin" })
table.insert(Event.Addon.SavedVariables.Load.End, { function(a) if a == "RaidStatus" then SVLoaded = true end end, addon.identifier, "Event.Addon.SavedVariables.Load.End" })
table.insert(Event.Buff.Add, { RS.AdEvent, addon.identifier, "Event.Buff.Add" })
table.insert(Event.Unit.Availability.Full, { RS.PlayerAvailable, addon.identifier, "Event.Unit.Availability.Full" })

print(string.format("v%s loaded.", addon.toc.Version))